Code

octopus: make merge process simpler to follow
authorStephen Boyd <bebarino@gmail.com>
Sat, 12 Dec 2009 00:38:57 +0000 (16:38 -0800)
committerJunio C Hamano <gitster@pobox.com>
Mon, 14 Dec 2009 07:17:46 +0000 (23:17 -0800)
Its not very easy to understand what heads are being merged given
the current output of an octopus merge. Fix this by replacing the
sha1 with the (usually) better description in GITHEAD_<SHA1>.

Suggested-by: Jari Aalto <jari.aalto@cante.net>
Signed-off-by: Stephen Boyd <bebarino@gmail.com>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
git-merge-octopus.sh
t/t7602-merge-octopus-many.sh

index 1dadbb49666c6d796df76babbfd291a2de4357e4..3bb1acd527b2fb58986fa49823ff1fe2dde4c61a 100755 (executable)
@@ -61,12 +61,13 @@ do
                exit 2
        esac
 
+       eval pretty_name=\${GITHEAD_$SHA1:-$SHA1}
        common=$(git merge-base --all $SHA1 $MRC) ||
-               die "Unable to find common commit with $SHA1"
+               die "Unable to find common commit with $pretty_name"
 
        case "$LF$common$LF" in
        *"$LF$SHA1$LF"*)
-               echo "Already up-to-date with $SHA1"
+               echo "Already up-to-date with $pretty_name"
                continue
                ;;
        esac
@@ -81,7 +82,7 @@ do
                # tree as the intermediate result of the merge.
                # We still need to count this as part of the parent set.
 
-               echo "Fast forwarding to: $SHA1"
+               echo "Fast-forwarding to: $pretty_name"
                git read-tree -u -m $head $SHA1 || exit
                MRC=$SHA1 MRT=$(git write-tree)
                continue
@@ -89,7 +90,7 @@ do
 
        NON_FF_MERGE=1
 
-       echo "Trying simple merge with $SHA1"
+       echo "Trying simple merge with $pretty_name"
        git read-tree -u -m --aggressive  $common $MRT $SHA1 || exit 2
        next=$(git write-tree 2>/dev/null)
        if test $? -ne 0
index 01e5415e943f3e16154f2f4d999f85a9d8b6ae49..73770332266973018a2fe397c856b7e9c7ca6431 100755 (executable)
@@ -49,4 +49,37 @@ test_expect_success 'merge c1 with c2, c3, c4, ... c29' '
        done
 '
 
+cat >expected <<\EOF
+Trying simple merge with c2
+Trying simple merge with c3
+Trying simple merge with c4
+Merge made by octopus.
+ c2.c |    1 +
+ c3.c |    1 +
+ c4.c |    1 +
+ 3 files changed, 3 insertions(+), 0 deletions(-)
+ create mode 100644 c2.c
+ create mode 100644 c3.c
+ create mode 100644 c4.c
+EOF
+
+test_expect_success 'merge output uses pretty names' '
+       git reset --hard c1 &&
+       git merge c2 c3 c4 >actual &&
+       test_cmp actual expected
+'
+
+cat >expected <<\EOF
+Already up-to-date with c4
+Trying simple merge with c5
+Merge made by octopus.
+ c5.c |    1 +
+ 1 files changed, 1 insertions(+), 0 deletions(-)
+ create mode 100644 c5.c
+EOF
+
+test_expect_success 'merge up-to-date output uses pretty names' '
+       git merge c4 c5 >actual &&
+       test_cmp actual expected
+'
 test_done